# Uninstallation script of Debookee's Packet Tool

#Debookee can't launch directly such script due to macOS security
#Execute the script by clicking on "Play" icon or menu Script -> Play

#This script unload and delete the packet capture tool of Debookee
#It resets an internal process of Debookee only : doesn't touch to the whole app or any other macOS process
#It needs admin rights to execute

# ----------------------------------

tell application "Finder"
	
	if exists POSIX file "/Library/LaunchDaemons/com.iwaxx.Debookee.PacketTool.plist" then
		
		#We first load it with -w to enable it if disabled by a 3rd party app
		do shell script "launchctl load -w /Library/LaunchDaemons/com.iwaxx.Debookee.PacketTool.plist" with administrator privileges
		
		#Unload it before deletion
		do shell script "launchctl unload /Library/LaunchDaemons/com.iwaxx.Debookee.PacketTool.plist" with administrator privileges
		
		#Let's delete it
		do shell script "rm -f /Library/LaunchDaemons/com.iwaxx.Debookee.PacketTool.plist" with administrator privileges
		
	end if
	
	#Deletion of the packet analyzer helper tool
	do shell script "rm -f /Library/PrivilegedHelperTools/com.iwaxx.Debookee.PacketTool" with administrator privileges
	
end tell

# ----------------------------------
