#!/bin/sh

# Current user using Debookee is passed as first argument

# Create the group access_bpf if doesn't exist
# Set the membership to current user
# copy the plist to /Library/LaunchDaemons/org.wireshark.ChmodBPF.plist
# Set permissions on /Library/LaunchDaemons/org.wireshark.ChmodBPF.plist
# Load the plist

# The plist loads /Library/Application Support/Wireshark/ChmodBPF/ChmodBPF


CHMOD_BPF="/Library/LaunchDaemons/org.wireshark.ChmodBPF.plist"
BPF_GROUP="access_bpf"
BPF_GROUP_NAME="BPF device access ACL"

dscl . -read /Groups/"$BPF_GROUP" > /dev/null 2>&1 || echo "chmodbpf-install.sh - Creating $BPF_GROUP"; dseditgroup -q -o create "$BPF_GROUP"
echo "chmodbpf-install.sh - Adding $1 to $BPF_GROUP"
dseditgroup -q -o edit -a "$1" -t user "$BPF_GROUP"

echo "Copy plist to $CHMOD_BPF"
cp "/Library/Application Support/Wireshark/ChmodBPF/org.wireshark.ChmodBPF.plist" \
    "$CHMOD_BPF"
echo "chmod 755 on $CHMOD_BPF"
chmod 755 "$CHMOD_BPF"
echo "chown root:wheel on $CHMOD_BPF"
chown root:wheel "$CHMOD_BPF"

echo "unloading $CHMOD_BPF"
launchctl unload "$CHMOD_BPF"
echo "loading $CHMOD_BPF"
launchctl load -w "$CHMOD_BPF"