
-- Capture filter brings us only type data
local wifi_plugins = {}
local time_epoch_data = 0
local time_epoch_unknown = 0
local frame_unknowns = {}

local wlan_good = Listener.new("wlan", "radiotap.flags.badfcs == 0")

local frame_len_f                     = Field.new("frame.len")
local frame_time_epoch_f              = Field.new("frame.time_epoch")

local radiotap_length_f               = Field.new("radiotap.length")
local radiotap_channel_freq_f         = Field.new("radiotap.channel.freq")
local radiotap_dbm_antsignal_f        = Field.new("radiotap.dbm_antsignal")

--local wlan_f                          = Field.new("wlan")
local wlan_fc_retry_f                 = Field.new("wlan.fc.retry")
local wlan_fc_type_f                  = Field.new("wlan.fc.type")
local wlan_fc_subtype_f               = Field.new("wlan.fc.subtype")
local wlan_fc_type_subtype_f          = Field.new("wlan.fc.type_subtype")
local wlan_ta_f                       = Field.new("wlan.ta")
local wlan_ra_f                       = Field.new("wlan.ra")
local wlan_fc_ds_f                    = Field.new("wlan.fc.ds")

local data_len_f                      = Field.new("data.len")

local wlan_radio_phy_f                = Field.new("wlan_radio.phy")
local wlan_radio_data_rate_f          = Field.new("wlan_radio.data_rate")

local wlan_radio_11n_mcs_index_f      = Field.new("wlan_radio.11n.mcs_index")
local wlan_radio_11n_short_gi_f       = Field.new("wlan_radio.11n.short_gi")
local wlan_radio_11n_bandwidth_f      = Field.new("wlan_radio.11n.bandwidth")
local wlan_radio_11n_ness_f           = Field.new("wlan_radio.11n.ness")        -- Seen with PPI headers

local wlan_radio_11ac_mcs_f           = Field.new("wlan_radio.11ac.mcs")
local wlan_radio_11ac_short_gi_f      = Field.new("wlan_radio.11ac.short_gi")
local wlan_radio_11ac_bandwidth_f     = Field.new("wlan_radio.11ac.bandwidth")
local wlan_radio_11ac_nss_f           = Field.new("wlan_radio.11ac.nss")


function wlan_good.packet(pinfo,tvb,tapinfo)
    
    -- print("wlan.packet called")
    
    local frame_time_epoch = ''
    
    if (frame_time_epoch_f() ~= nil) then
        
        -- Lua doesn't handle float, stripping chars to transform in integer
        -- 1452006449.297822000
        -- Changed to 2006449297 - Delete 1st 3 chars - last 6 - point
        frame_time_epoch = tostring(frame_time_epoch_f())
        frame_time_epoch = frame_time_epoch:gsub("^...", "")
        frame_time_epoch = frame_time_epoch:gsub("......$", "")
        frame_time_epoch = frame_time_epoch:gsub("%.", "")
        frame_time_epoch = tonumber(frame_time_epoch)

        if (time_epoch_data == 0) then
            -- initialize
            time_epoch_data = frame_time_epoch
        end
        
        if (time_epoch_unknown == 0) then
            -- initialize
            time_epoch_unknown = frame_time_epoch
        end
        
    end
    
    -- Only type data
    if (wlan_fc_type_f() ~= nil) then
        
        if (tostring(wlan_fc_type_f()) == "2") then
            
            local frame_len = ''
            local radiotap_length = ''
            local radiotap_channel_freq = ''
            local radiotap_dbm_antsignal = ''
            local wlan_ta = ''
            local wlan_ra = ''
            local wlan_fc_ds = ''
            local data_len = ''
        
            local wlan_radio_phy = ''
            local wlan_radio_data_rate = ''
            local wlan_radio_mcs = ''
            local wlan_radio_short_gi = ''
            local wlan_radio_bandwidth = ''
            local wlan_radio_nss = ''
    
            -- print("Total: " .. total_rxbitmask)
            -- print("SSID: " .. tostring(wlan_ssid_f()) .. " - Number SS: " .. wlan_ht_mcsset_rxbitmask)
    
            if (frame_len_f() ~= nil) then
                frame_len = tonumber(tostring(frame_len_f()))
            end
    
            if (radiotap_length_f() ~= nil) then
                radiotap_length = tonumber(tostring(radiotap_length_f()))
            else
                radiotap_length = 25
            end
    
            if (radiotap_channel_freq_f() ~= nil) then
                radiotap_channel_freq = tostring(radiotap_channel_freq_f())
            end
    
            if (wlan_ta_f() ~= nil) then
                wlan_ta = tostring(wlan_ta_f())
            end
    
            if (wlan_ra_f() ~= nil) then
                wlan_ra = tostring(wlan_ra_f())
            end
    
            if (wlan_fc_ds_f() ~= nil) then
                wlan_fc_ds = tostring(wlan_fc_ds_f())
            end
    
            if (data_len_f() ~= nil) then
                data_len = tonumber(tostring(data_len_f()))
            end
        
            -- WLAN_RADIO
            if (wlan_radio_phy_f() ~= nil) then
                wlan_radio_phy = tonumber(tostring(wlan_radio_phy_f()))
            
                if (wlan_radio_data_rate_f() ~= nil) then
                    wlan_radio_data_rate = tostring(wlan_radio_data_rate_f())
                end
            
                if (wlan_radio_phy == 7) then
            
                    -- 802.11n
                    if (wlan_radio_11n_mcs_index_f() ~= nil) then
                        wlan_radio_mcs = tostring(wlan_radio_11n_mcs_index_f())
                    end
            
                    if (wlan_radio_11n_short_gi_f() ~= nil) then
                        wlan_radio_short_gi = tostring(wlan_radio_11n_short_gi_f())
                    end
            
                    if (wlan_radio_11n_bandwidth_f() ~= nil) then
                        wlan_radio_bandwidth = tostring(wlan_radio_11n_bandwidth_f())
                    end
            
                    if (wlan_radio_11n_ness_f() ~= nil) then
                        wlan_radio_nss = tostring(wlan_radio_11n_ness_f())
                    end
                elseif (wlan_radio_phy == 8) then
            
                    -- 802.11ac
                    if (wlan_radio_11ac_mcs_f() ~= nil) then
                        wlan_radio_mcs = tostring(wlan_radio_11ac_mcs_f())
                    end
            
                    if (wlan_radio_11ac_short_gi_f() ~= nil) then
                        wlan_radio_short_gi = tostring(wlan_radio_11ac_short_gi_f())
                    end
            
                    if (wlan_radio_11ac_bandwidth_f() ~= nil) then
                        wlan_radio_bandwidth = tostring(wlan_radio_11ac_bandwidth_f())
                    end
            
                    if (wlan_radio_11ac_nss_f() ~= nil) then
                        wlan_radio_nss = tostring(wlan_radio_11ac_nss_f())
                    end
                end
            end
    
            if (radiotap_length and frame_len and wlan_ta and wlan_ra and wlan_fc_ds) then
        
                local macAddress = ''
                local bssid = ''
                local data_tx = 0
                local data_rx = 0
                local data_frame_tx = 0
                local data_frame_rx = 0
                local data_frame_tx_retransmit = 0
                local data_frame_rx_retransmit = 0
                local wlan_radio_tx_data_rate = ''
                local wlan_radio_rx_data_rate = ''
    
                if (wlan_fc_ds == "0x00000001") then
       
                   -- Client -> AP - ToDS:1/FromDS:0 
                   -- TX --
                   
                   -- We're interested in radio signal in that case only, not a packet from the AP
                   if (radiotap_dbm_antsignal_f() ~= nil) then
                       radiotap_dbm_antsignal = tostring(radiotap_dbm_antsignal_f())
                   end
                   
                   macAddress = wlan_ta
                   bssid = wlan_ra
                   data_frame_tx = 1

                   if (wlan_fc_retry_f() ~= nil) then
                       data_frame_tx_retransmit = tonumber(tostring(wlan_fc_retry_f()))
                   end
                   
       
                   if (tostring(wlan_fc_subtype_f()) ~= "4" and        -- Null (no data)
                       tostring(wlan_fc_subtype_f()) ~= "5" and        -- CF-Ack (no data)
                       tostring(wlan_fc_subtype_f()) ~= "6" and        -- CF-Poll (no data)
                       tostring(wlan_fc_subtype_f()) ~= "7" and        -- CF-Ack + CF-Poll (no data)
                       tostring(wlan_fc_subtype_f()) ~= "12" and       -- QoS Null (no data)
                       tostring(wlan_fc_subtype_f()) ~= "14" and       -- QoS CF-Poll (no data)
                       tostring(wlan_fc_subtype_f()) ~= "15") then     -- QoS CF-Ack + CF-Poll (no data)
                           
                       -- Not a null packet, we keep data and data_rate (else slow data_rate)
                       wlan_radio_tx_data_rate = wlan_radio_data_rate
                       
                       if (data_len_f()) then
                           -- encrypted
                           data_tx = data_len
                       else
                           -- clear text packet - wlan length minimum 24 + FCS 4
                           -- radio_length is sometime nil
                           data_tx = frame_len - radiotap_length - 28
                       end 
                    end
                    
                elseif (wlan_fc_ds == "0x00000002") then
        
                    -- AP -> Client - ToDS:0/FromDS:1
                    -- RX --
                    macAddress = wlan_ra
                    bssid = wlan_ta
                    data_frame_rx = 1

                    if (wlan_fc_retry_f() ~= nil) then
                        data_frame_rx_retransmit = tonumber(tostring(wlan_fc_retry_f()))
                    end
                    
                    if (tostring(wlan_fc_subtype_f()) ~= "4" and        -- Null (no data)
                        tostring(wlan_fc_subtype_f()) ~= "5" and        -- CF-Ack (no data)
                        tostring(wlan_fc_subtype_f()) ~= "6" and        -- CF-Poll (no data)
                        tostring(wlan_fc_subtype_f()) ~= "7" and        -- CF-Ack + CF-Poll (no data)
                        tostring(wlan_fc_subtype_f()) ~= "12" and       -- QoS Null (no data)
                        tostring(wlan_fc_subtype_f()) ~= "14" and       -- QoS CF-Poll (no data)
                        tostring(wlan_fc_subtype_f()) ~= "15") then     -- QoS CF-Ack + CF-Poll (no data)
                           
                        -- Not a null packet, we keep data and data_rate (else slow data_rate)
                        wlan_radio_rx_data_rate = wlan_radio_data_rate
                       
                        if (data_len_f()) then
                            -- encrypted
                            data_rx = data_len
                        else
                            -- clear text packet - wlan length minimum 24 + FCS 4
                            -- radio_length is sometime nil
                            data_rx = frame_len - radiotap_length - 28
                        end 
                     end
                else
                    -- Quit if not 1 or 2
                    return
                end

                local wifi_plugin = wifi_plugins[macAddress]

                if not wifi_plugin then
                    --print("New plugin", macAddress)
                    wifi_plugin = {}
                    wifi_plugin['_type_subtype_tx_table'] = {}
                    wifi_plugin['_type_subtype_rx_table'] = {}
                    wifi_plugin['macAddress'] = macAddress         -- To be used in JSON
                    wifi_plugin['bssid'] = bssid
                    wifi_plugin['jsonType'] = 'wifiClient'
                    wifi_plugins[macAddress] = wifi_plugin
                end
                
                if (data_frame_tx > 0) then
                    wifi_plugin['data_tx'] = ((wifi_plugin['data_tx'] ~= nil) and wifi_plugin['data_tx'] or 0) + data_tx
                    wifi_plugin['data_frame_tx'] = ((wifi_plugin['data_frame_tx'] ~= nil) and wifi_plugin['data_frame_tx'] or 0) + data_frame_tx
                    wifi_plugin['data_frame_tx_retransmit'] = ((wifi_plugin['data_frame_tx_retransmit'] ~= nil) and wifi_plugin['data_frame_tx_retransmit'] or 0) + data_frame_tx_retransmit
                    wifi_plugin['_type_subtype_tx_table'][tostring(wlan_fc_type_subtype_f())] = ((wifi_plugin['_type_subtype_tx_table'][tostring(wlan_fc_type_subtype_f())] ~= nil) and wifi_plugin['_type_subtype_tx_table'][tostring(wlan_fc_type_subtype_f())] or 0) + 1
                else
                    wifi_plugin['data_rx'] = ((wifi_plugin['data_rx'] ~= nil) and wifi_plugin['data_rx'] or 0) + data_rx
                    wifi_plugin['data_frame_rx'] = ((wifi_plugin['data_frame_rx'] ~= nil) and wifi_plugin['data_frame_rx'] or 0) + data_frame_rx
                    wifi_plugin['data_frame_rx_retransmit'] = ((wifi_plugin['data_frame_rx_retransmit'] ~= nil) and wifi_plugin['data_frame_rx_retransmit'] or 0) + data_frame_rx_retransmit
                    wifi_plugin['_type_subtype_rx_table'][tostring(wlan_fc_type_subtype_f())] = ((wifi_plugin['_type_subtype_rx_table'][tostring(wlan_fc_type_subtype_f())] ~= nil) and wifi_plugin['_type_subtype_rx_table'][tostring(wlan_fc_type_subtype_f())] or 0) + 1
                end
                
                -- in case we've seen a packet from AP, radiotap_dbm_signal is '' (not a client packet)
                -- Update only if we have a valid value for radio, and wifi_plugin is stil nil, then don't update it till next refresh
                --print(macAddress, wifi_plugin['radiotap_dbm_antsignal'], radiotap_dbm_antsignal)
                -- First time: nil -> value or '' / Then if '' -> value
                
                if (wifi_plugin['radiotap_dbm_antsignal'] == nil or (wifi_plugin['radiotap_dbm_antsignal'] == '' and radiotap_dbm_antsignal ~= '')) then
                    -- Initialize to value or ''
                    wifi_plugin['radiotap_dbm_antsignal'] = radiotap_dbm_antsignal
                end
                
                if (wifi_plugin['wlan_radio_tx_data_rate'] == nil or (wifi_plugin['wlan_radio_tx_data_rate'] == '' and wlan_radio_tx_data_rate ~= '')) then
                    -- Initialize to value or ''
                    wifi_plugin['wlan_radio_tx_data_rate'] = wlan_radio_tx_data_rate
                end
                
                if (wifi_plugin['wlan_radio_rx_data_rate'] == nil or (wifi_plugin['wlan_radio_rx_data_rate'] == '' and wlan_radio_rx_data_rate ~= '')) then
                    -- Initialize to value or ''
                    wifi_plugin['wlan_radio_rx_data_rate'] = wlan_radio_rx_data_rate
                end
                
                -- Send time_epoch for bandwidth calculation
                wifi_plugin['last_frame_time_epoch'] = frame_time_epoch
                
                -- After string manipulation, time_epoch is in ms
                --print('da', time_epoch, frame_time_epoch)
                if (frame_time_epoch > time_epoch_data+1000) then
                    
                    printJsonFromTable(wifi_plugins)
            
                    -- Will be reset on next loop
                    time_epoch_data=0
                end
            else
                --print("missing radiotap_length and frame_len and wlan_ta and wlan_ra and wlan_fc_ds")
            end -- else missing radiotap_length and frame_len and wlan_ta and wlan_ra and wlan_fc_ds

        elseif (tostring(wlan_fc_type_subtype_f()) == "4") then
            
            -- Probe Request
            local radiotap_dbm_antsignal = ''
            
            if (radiotap_dbm_antsignal_f() ~= nil) then
                radiotap_dbm_antsignal = tostring(radiotap_dbm_antsignal_f())
            end
            
            wifi_plugin = {}
            wifi_plugin['_type_subtype_tx_table'] = {}
            wifi_plugin['jsonType'] = 'wifiClient'
            wifi_plugin['macAddress'] = tostring(wlan_ta_f())
            wifi_plugin['radiotap_dbm_antsignal'] = radiotap_dbm_antsignal
            wifi_plugin['_type_subtype_tx_table'][tostring(wlan_fc_type_subtype_f())] = 1
            printJsonFromTable({ wifi_plugin })
        
        else
            -- We don't know sender/receiver - AP/Client: Block Ack / RTS / CTS
            -- We send them & Debookee will try to correlate from existing entries

            -- CTS/Ack has no wlan_ta
            local wlan_ta = ''
            local wlan_ra = ''
            local radiotap_dbm_antsignal = ''
            
            if (radiotap_dbm_antsignal_f() ~= nil) then
                radiotap_dbm_antsignal = tostring(radiotap_dbm_antsignal_f())
            end
            
            if (wlan_ta_f() ~= nil) then
                wlan_ta = tostring(wlan_ta_f())
            end
            
            -- Power-Save poll has no receive addr
            if (wlan_ra_f() ~= nil) then
                wlan_ra = tostring(wlan_ra_f())
            end
            
            local key = wlan_ra .. "-" .. wlan_ta
            
            -- Range them by wlan_ra as CTS/Ack has not wlan_ta
            local frame_unknown = frame_unknowns[key]

            if not frame_unknown then
                frame_unknown = {}
                frame_unknown['_type_subtype_table'] = {}
                frame_unknown['jsonType'] = 'wifiFrameUnknown'
                frame_unknown['wlan_ta'] = wlan_ta
                frame_unknown['wlan_ra'] = wlan_ra
                frame_unknown['_type_subtype_table'][tostring(wlan_fc_type_subtype_f())] = 1
                frame_unknowns[key] = frame_unknown
            else
                frame_unknown['_type_subtype_table'][tostring(wlan_fc_type_subtype_f())] = ((frame_unknown['_type_subtype_table'][tostring(wlan_fc_type_subtype_f())] ~= nil) and frame_unknown['_type_subtype_table'][tostring(wlan_fc_type_subtype_f())] or 0) + 1
            end
            
            
            --print('un', time_epoch, frame_time_epoch)
            if (frame_time_epoch > time_epoch_unknown+1000) then
                printJsonFromTable(frame_unknowns)
        
                -- Will be reset on next loop
                time_epoch_unknown=0
            end
            
            --printJsonFromTable({ wifi_plugin })
        
        end -- else wlan_fc_type_f is not data / nor probe request
    end -- else wlan_fc_type_f is nil
end

function wlan_good.draw()
  
    -- We miss last second values, but don't have the local variables wlan_radio_phy / etc ...
    --print('draw')
   
    printJsonFromTable(wifi_plugins)
    printJsonFromTable(frame_unknowns)


end

function printJsonFromTable(wifi_plugins)
    
    for macAddress,wifi_plugin in pairs(wifi_plugins) 
        do 
            --For unknown, macAddress is composed 24:a2:e1:f0:cd:97-68:9c:70:48:15:47
            --print("printJsonFromTable", macAddress)
            
            -- Json for type_subtype
            if (wifi_plugins[macAddress]['_type_subtype_tx_table'] ~= nil) then
                local type_subtype_dict = "{"
                for key,value in pairs(wifi_plugins[macAddress]['_type_subtype_tx_table'])
                    do 
                        if type_subtype_dict ~= "{" then
                            type_subtype_dict = type_subtype_dict .. ","
                        end
                        type_subtype_dict = type_subtype_dict .. "\"" .. key .. "\"" .. ":" .. "\"" .. value .. "\""
                end
                type_subtype_dict = type_subtype_dict .. "}"
                wifi_plugins[macAddress]['type_subtype_tx_dict'] = type_subtype_dict
            end
            
            if (wifi_plugins[macAddress]['_type_subtype_rx_table'] ~= nil) then
                local type_subtype_dict = "{"
                for key,value in pairs(wifi_plugins[macAddress]['_type_subtype_rx_table'])
                    do 
                        if type_subtype_dict ~= "{" then
                            type_subtype_dict = type_subtype_dict .. ","
                        end
                        type_subtype_dict = type_subtype_dict .. "\"" .. key .. "\"" .. ":" .. "\"" .. value .. "\""
                end
                type_subtype_dict = type_subtype_dict .. "}"
                wifi_plugins[macAddress]['type_subtype_rx_dict'] = type_subtype_dict
            end
            
            if (wifi_plugins[macAddress]['_type_subtype_table'] ~= nil) then
                local type_subtype_dict = "{"
                for key,value in pairs(wifi_plugins[macAddress]['_type_subtype_table'])
                    do 
                        if type_subtype_dict ~= "{" then
                            type_subtype_dict = type_subtype_dict .. ","
                        end
                        type_subtype_dict = type_subtype_dict .. "\"" .. key .. "\"" .. ":" .. "\"" .. value .. "\""
                end
                type_subtype_dict = type_subtype_dict .. "}"
                wifi_plugins[macAddress]['type_subtype_dict'] = type_subtype_dict
            end
            
            
            local json = "{"
            for key,value in pairs(wifi_plugins[macAddress])
            do
                -- Don't parse keys beginning with _
                if (string.find(key, "^_") == nil) then 
                    if json ~= "{" then
                        json = json .. ","
                    end
                    
                    -- Add Quote only to values, not to json
                    local displayed_value
                    if (string.find(value, "^{") == nil) then
                        displayed_value = "\"" .. value .. "\""
                    else
                        displayed_value = value
                    end
                    json = json .. "\"" .. key .. "\"" .. ":" .. displayed_value
                end
            end
            json = json .. "}"
            print(json)
    
    
            wifi_plugins[macAddress] = nil
    end
end

-- static const value_string phy_vals[] = {
--     { PHDR_802_11_PHY_11_FHSS,       "802.11 FHSS" },
--     { PHDR_802_11_PHY_11_IR,         "802.11 IR" },
--     { PHDR_802_11_PHY_11_DSSS,       "802.11 DSSS" },
--     { PHDR_802_11_PHY_11B,           "802.11b" },
--     { PHDR_802_11_PHY_11A,           "802.11a" },
--     { PHDR_802_11_PHY_11G,           "802.11g" },
--     { PHDR_802_11_PHY_11N,           "802.11n" },
--     { PHDR_802_11_PHY_11AC,          "802.11ac" },
--     { 0, NULL }
-- };

-- static const value_string bandwidth_vals[] = {
--     { PHDR_802_11_BANDWIDTH_20_MHZ,  "20 MHz" },
--     { PHDR_802_11_BANDWIDTH_40_MHZ,  "40 MHz" },
--     { PHDR_802_11_BANDWIDTH_20_20L,  "20 MHz + 20 MHz lower" },
--     { PHDR_802_11_BANDWIDTH_20_20U,  "20 MHz + 20 MHz upper" },
--     { PHDR_802_11_BANDWIDTH_80_MHZ,  "80 MHz" },
--     { PHDR_802_11_BANDWIDTH_40_40L,  "40 MHz + 40 MHz lower" },
--     { PHDR_802_11_BANDWIDTH_40_40U,  "40 MHz + 40 MHz upper" },
--     { PHDR_802_11_BANDWIDTH_20LL,    "20 MHz, channel 1/4" },
--     { PHDR_802_11_BANDWIDTH_20LU,    "20 MHz, channel 2/4" },
--     { PHDR_802_11_BANDWIDTH_20UL,    "20 MHz, channel 3/4" },
--     { PHDR_802_11_BANDWIDTH_20UU,    "20 MHz, channel 4/4" },
--     { PHDR_802_11_BANDWIDTH_160_MHZ, "160 MHz" },
--     { PHDR_802_11_BANDWIDTH_80_80L,  "80 MHz + 80 MHz lower" },
--     { PHDR_802_11_BANDWIDTH_80_80U,  "80 MHz + 80 MHz upper" },
--     { PHDR_802_11_BANDWIDTH_40LL,    "40 MHz, channel 1/4" },
--     { PHDR_802_11_BANDWIDTH_40LU,    "40 MHz, channel 2/4" },
--     { PHDR_802_11_BANDWIDTH_40UL,    "40 MHz, channel 3/4" },
--     { PHDR_802_11_BANDWIDTH_40UU,    "40 MHz, channel 4/4" },
--     { PHDR_802_11_BANDWIDTH_20LLL,   "20 MHz, channel 1/8" },
--     { PHDR_802_11_BANDWIDTH_20LLU,   "20 MHz, channel 2/8" },
--     { PHDR_802_11_BANDWIDTH_20LUL,   "20 MHz, channel 3/8" },
--     { PHDR_802_11_BANDWIDTH_20LUU,   "20 MHz, channel 4/8" },
--     { PHDR_802_11_BANDWIDTH_20ULL,   "20 MHz, channel 5/8" },
--     { PHDR_802_11_BANDWIDTH_20ULU,   "20 MHz, channel 6/8" },
--     { PHDR_802_11_BANDWIDTH_20UUL,   "20 MHz, channel 7/8" },
--     { PHDR_802_11_BANDWIDTH_20UUU,   "20 MHz, channel 8/8" },
--     { 0, NULL }
-- };
