#!/bin/bash

# Take care with "$1" in case of space. Tried '$1', but variable not replaced, stays with "$1" string

# Argument: Full path folder (on Desktop) created by Debookee
# command > file-name 2>&1
# command-name &>file
# ./zipDebugLogs.sh ~/Desktop/debookee_logs_2017-03-02-181259 &> ~/Desktop/debookee_logs_2017-03-02-181259/log_errors.log

# To retrieve /var/log/DiagnosticMessages/2017.03.20.asl
ASL_DATE=`date +%Y.%m.%d`
ASL_DATE_YESTERDAY=`date -v-1d +%Y.%m.%d`

# com.iwaxx.Debookee 2021-03-12--13-41-47-068.log
# com.iwaxx.Debookee.PacketTool 2021-03-12--13-41-49-397.log
cp ~/Library/Logs/Debookee/*Debookee* "$1"
cp ~/Library/Logs/DiagnosticReports/*Debookee* "$1"             # No matches
cp /Library/Logs/DiagnosticReports/*Debookee* "$1"              # No matches

# Also backups /etc/pf.conf.debookee.620501588.265196
cp /etc/pf.conf* "$1"

# senderImagePath: Process name - processImagePath: includes senderImagePath + All Apple internals concerning process
log show --predicate 'eventType == logEvent && (eventMessage contains[cd] "debookee" || processImagePath contains[cd] "debookee")' --last 4d > "$1"/log_show_last_4d.log
syslog -f /var/log/DiagnosticMessages/$ASL_DATE_YESTERDAY.asl -F raw -T utc | grep -i debookee >> "$1"/syslog_asl_last_2d.log
syslog -f /var/log/DiagnosticMessages/$ASL_DATE.asl -F raw -T utc | grep -i debookee >> "$1"/syslog_asl_last_2d.log

zip -r "$1.zip" "$1"
rm -rf "$1"
